import os, pygame

from math import sqrt
from random import randint
from string import Template, atoi
from math import degrees, sqrt, sin, cos, atan2

from util import *

from pygame.locals import *

class enemy(pygame.sprite.Sprite):
    def __init__(self, x, y, enemyclass, attributes):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer
        self.attributes = attributes
        self.enemyclass = enemyclass
        self.loadimages()
        self.animationtimer = 0
        self.animationframe = 0
        self.targetx = 0
        self.targety = 0
        self.targettimer = 0
        self.hastarget = False
        self.chooseframe()
        self.angle = 0.0
        self.offsetx = 0
        self.offsety = 0
        self.resttimer = randint(0, 50)
        self.x = x
        self.y = y
        self.damaged = False
        self.damagedvelx = 0
        self.damagedvely = 0
        self.damagedtimer = 0
        self.deleted = False
        self.move()

    def loadimages(self):
        if (self.enemyclass == 'caw'):
            self.image1u, self.rect = load_image("caw1.png", -1)
            self.image2u, temp = load_image("caw2.png", -1)
            self.image3u, temp = load_image("caw3.png", -1)
            self.image1l = pygame.transform.rotate(self.image1u, 90)
            self.image2l = pygame.transform.rotate(self.image2u, 90)
            self.image3l = pygame.transform.rotate(self.image3u, 90)
            self.image1d = pygame.transform.rotate(self.image1u, 180)
            self.image2d = pygame.transform.rotate(self.image2u, 180)
            self.image3d = pygame.transform.rotate(self.image3u, 180)
            self.image1r = pygame.transform.rotate(self.image1u, 270)
            self.image2r = pygame.transform.rotate(self.image2u, 270)
            self.image3r = pygame.transform.rotate(self.image3u, 270)
            self.facing = FACING_UP
            self.health = 2
        if (self.enemyclass == 'hog'):
            self.image1u, self.rect = load_image("groundhog1.png", -1)
            self.image2u, temp = load_image("groundhog2.png", -1)
            self.image1l = pygame.transform.rotate(self.image1u, 90)
            self.image2l = pygame.transform.rotate(self.image2u, 90)
            self.image1d = pygame.transform.rotate(self.image1u, 180)
            self.image2d = pygame.transform.rotate(self.image2u, 180)
            self.image1r = pygame.transform.rotate(self.image1u, 270)
            self.image2r = pygame.transform.rotate(self.image2u, 270)
            self.facing = FACING_UP
            self.health = 2
        if (self.enemyclass == 'kid'):
            self.image1r, self.rect = load_image("char/kid1.png", -1)
            self.image2r, temp = load_image("char/kid2.png", -1)
            self.image3r, temp = load_image("char/kid3.png", -1)
            self.image1u = pygame.transform.rotate(self.image1r, 90)
            self.image2u = pygame.transform.rotate(self.image2r, 90)
            self.image3u = pygame.transform.rotate(self.image3r, 90)
            self.image1l = pygame.transform.rotate(self.image1r, 180)
            self.image2l = pygame.transform.rotate(self.image2r, 180)
            self.image3l = pygame.transform.rotate(self.image3r, 180)
            self.image1d = pygame.transform.rotate(self.image1r, 270)
            self.image2d = pygame.transform.rotate(self.image2r, 270)
            self.image3d = pygame.transform.rotate(self.image3r, 270)
            self.facing = FACING_RIGHT
            self.health = 2
        if (self.enemyclass == 'gkid'):
            self.image1r, self.rect = load_image("char/gkid1.png", -1)
            self.image2r, temp = load_image("char/gkid2.png", -1)
            self.image3r, temp = load_image("char/gkid3.png", -1)
            self.image1u = pygame.transform.rotate(self.image1r, 90)
            self.image2u = pygame.transform.rotate(self.image2r, 90)
            self.image3u = pygame.transform.rotate(self.image3r, 90)
            self.image1l = pygame.transform.rotate(self.image1r, 180)
            self.image2l = pygame.transform.rotate(self.image2r, 180)
            self.image3l = pygame.transform.rotate(self.image3r, 180)
            self.image1d = pygame.transform.rotate(self.image1r, 270)
            self.image2d = pygame.transform.rotate(self.image2r, 270)
            self.image3d = pygame.transform.rotate(self.image3r, 270)
            self.facing = FACING_RIGHT
            self.health = 8

    def chooseframe(self):
        if (self.animationframe == 0):
            if (self.facing == FACING_UP):
                self.image = self.image1u
            elif (self.facing == FACING_DOWN):
                self.image = self.image1d
            elif (self.facing == FACING_LEFT):
                self.image = self.image1l
            elif (self.facing == FACING_RIGHT):
                self.image = self.image1r
        elif (self.animationframe == 1):
            if (self.facing == FACING_UP):
                self.image = self.image2u
            elif (self.facing == FACING_DOWN):
                self.image = self.image2d
            elif (self.facing == FACING_LEFT):
                self.image = self.image2l
            elif (self.facing == FACING_RIGHT):
                self.image = self.image2r
        elif (self.animationframe == 2):
            if (self.facing == FACING_UP):
                self.image = self.image3u
            elif (self.facing == FACING_DOWN):
                self.image = self.image3d
            elif (self.facing == FACING_LEFT):
                self.image = self.image3l
            elif (self.facing == FACING_RIGHT):
                self.image = self.image3r

    def crowfacing(self, player):
        if (abs(player.rect.left - self.rect.left) > abs(player.rect.top - self.rect.top)): 
          if (player.rect.left > self.rect.left):
              self.facing = FACING_RIGHT
          elif (player.rect.left < self.rect.left):
              self.facing = FACING_LEFT
        else:
          if (player.rect.top > self.rect.top):
              self.facing = FACING_DOWN
          else:
              self.facing = FACING_UP
    
    def hitplayer(self, player):
        if (not(self.damaged)):
            if (not(self.enemyclass == 'hog' and self.animationframe == 0)): 
                self.damaged = True
                angle = atan2((self.rect.centery-player.rect.centery),(self.rect.centerx-player.rect.centerx))
                self.damagedvelx = int(5*cos(angle))
                self.damagedvely = int(5*sin(angle))
                self.damagedtimer = 0

    def updatehog(self, player, blockingobjects, scrolloffsetx, scrolloffsety):
        self.chooseframe()
        if (not(self.hastarget)):
            self.targettimer += 1
            if (self.targettimer > 20):
                self.targettimer = 0
                if (self.hastarget):
                    newrect = pygame.Rect(self.targetx, self.targety, 16, 16)
                    for i in blockingobjects:
                        if (i.rect.colliderect(newrect)):
                            self.hastarget = False
                while (not(self.hastarget)):
                  self.hastarget = False
                  facing = randint(0, 3)
                  if (facing == FACING_UP and self.facing != FACING_DOWN):
                      self.targetx = self.x
                      self.targety = self.y-16
                      self.facing = FACING_UP
                      self.hastarget = True
                  elif (facing == FACING_DOWN and self.facing != FACING_UP):
                      self.targetx = self.x
                      self.targety = self.y+16
                      self.facing = FACING_DOWN
                      self.hastarget = True
                  elif (facing == FACING_RIGHT and self.facing != FACING_LEFT):
                      self.targetx = self.x+16
                      self.targety = self.y
                      self.facing = FACING_RIGHT
                      self.hastarget = True
                  elif (facing == FACING_LEFT and self.facing != FACING_RIGHT):
                      self.targetx = self.x-16
                      self.targety = self.y
                      self.facing = FACING_LEFT
                      self.hastarget = True
                  newrect = pygame.Rect(self.targetx, self.targety, 16, 16)
                  for i in blockingobjects:
                      if (i.rect.colliderect(newrect)):
                          self.hastarget = False
        else:
              if (not(self.rect.colliderect(player.rect))):
                  oldx = self.x
                  oldy = self.y
                  speed = 1
                  if (self.targetx < self.x):
                      self.x -= speed
                  elif (self.targetx > self.x):
                      self.x += speed
                  if (self.targety < self.y):
                      self.y -= speed
                  elif (self.targety > self.y):
                      self.y += speed
                  self.move()
                  self.animationtimer += 1
                  if (self.animationtimer > 50):
                      self.animationtimer = 0
                      if (self.animationframe):
                          self.animationframe = 0
                      else:
                          self.animationframe = 1
                  self.targettimer += speed
                  if (pygame.sprite.spritecollideany(self, blockingobjects)):
                      self.y = oldy
                      self.x = oldx
                      self.move()
                      self.hastarget = False
                      self.targettimer = 0
              else:
                  player.hitenemy(self)
                  self.animationframe = 0
                  self.hastarget = False
                  self.targettimer = 0

              if (self.targettimer > 16):
                  self.hastarget = False
          

    def updatecrow(self, player, scrolloffsetx, scrolloffsety):
          self.crowfacing(player)
          self.chooseframe()
          
          if (not(self.hastarget)):
              self.resttimer += 1
              if (self.resttimer > 50):
                  self.hastarget = True
                  if (self.x > player.rect.centerx):
                      self.targetx = player.rect.centerx - 100
                  else:
                      self.targetx = player.rect.centerx + 100
                  if (self.y > player.rect.centery):
                      self.targety = player.rect.centery - 100
                  else:
                      self.targety = player.rect.centery + 100
                  self.targettimer = 0
          else:
              if (not(self.rect.colliderect(player.rect))):
                  oldx = self.x
                  oldy = self.y
                  if (self.animationframe == 2):
                      speed = .5
                  else:
                      speed = 1
                  if (self.targetx < self.x):
                      self.x -= speed
                  elif (self.targetx > self.x):
                      self.x += speed
                  if (self.targety < self.y):
                      self.y -= speed
                  elif (self.targety > self.y):
                      self.y += speed
                  self.move()
                  if (oldx == self.x and oldy == self.y):
                    self.animationframe = 0
                  elif (self.distance(player.rect.centerx, player.rect.centery) > 100):
                    self.animationframe = 2 
                  else:
                    self.animationframe = 1
              else:
                  self.animationframe = 0
                  player.hitenemy(self)
                  self.hastarget = True
                  self.targettimer = 50
                  self.resttimer = 0

              self.targettimer += 1
              if (self.targettimer > 50):
                  self.hastarget = False
                  self.animationframe = 0
                  self.resttimer = 0

    def updatekid(self, player, blockingobjects, scrolloffsetx, scrolloffsety, green=False):
        self.chooseframe()
        if (not(self.hastarget)):
            if (player.rect.top > self.y - 16 and player.rect.top < self.y+16):
              self.hastarget = True
              self.targety = self.y
              self.targetx = player.rect.left
              if (self.targetx > self.x):
                self.facing = FACING_RIGHT
              else:
                self.facing = FACING_LEFT
            if (player.rect.left > self.x - 16 and player.rect.left < self.x+16):
              self.hastarget = True
              self.targety = player.rect.top
              self.targetx = self.x
              if (self.targety > self.y):
                self.facing = FACING_DOWN
              else:
                self.facing = FACING_UP
            if (self.hastarget):
                newrect = pygame.Rect(self.targetx, self.targety, 16, 16)
                for i in blockingobjects:
                    if (i.rect.colliderect(newrect)):
                        self.hastarget = False
            while (not(self.hastarget)):
              self.hastarget = False
              facing = randint(0, 3)
              if (facing == FACING_UP and self.facing != FACING_DOWN):
                  self.targetx = self.x
                  self.targety = self.y-16
                  self.facing = FACING_UP
                  self.hastarget = True
              elif (facing == FACING_DOWN and self.facing != FACING_UP):
                  self.targetx = self.x
                  self.targety = self.y+16
                  self.facing = FACING_DOWN
                  self.hastarget = True
              elif (facing == FACING_RIGHT and self.facing != FACING_LEFT):
                  self.targetx = self.x+16
                  self.targety = self.y
                  self.facing = FACING_RIGHT
                  self.hastarget = True
              elif (facing == FACING_LEFT and self.facing != FACING_RIGHT):
                  self.targetx = self.x-16
                  self.targety = self.y
                  self.facing = FACING_LEFT
                  self.hastarget = True
              newrect = pygame.Rect(self.targetx, self.targety, 16, 16)
              for i in blockingobjects:
                  if (i.rect.colliderect(newrect)):
                      self.hastarget = False
            self.targettimer=0
        else:
              if (not(self.rect.colliderect(player.rect))):
                  oldx = self.x
                  oldy = self.y
                  speed = 1
                  if (green):
                      if (self.facing == FACING_LEFT or self.facing == FACING_RIGHT):
                        if (player.rect.top > self.y - 16 and player.rect.top < self.y+16):
                          speed = 3
                      else:
                        if (player.rect.left > self.x - 16 and player.rect.left < self.x+16):
                          speed = 3
                  if (self.targetx < self.x):
                      self.x -= speed
                  elif (self.targetx > self.x):
                      self.x += speed
                  if (self.targety < self.y):
                      self.y -= speed
                  elif (self.targety > self.y):
                      self.y += speed
                  self.move()
                  if (oldx == self.x and oldy == self.y):
                    self.animationframe = 0
                  else:
                    self.animationtimer += speed
                    if (self.animationtimer > 10):
                        self.animationtimer = 0
                        if (self.animationframe == 1):
                          self.animationframe = 2 
                        else:
                          self.animationframe = 1
                  self.targettimer += speed
                  if (pygame.sprite.spritecollideany(self, blockingobjects)):
                      self.y = oldy
                      self.x = oldx
                      self.move()
                      self.animationframe = 0
                      self.hastarget = False
                      self.targettimer = 0
              else:
                  self.animationframe = 0
                  player.hitenemy(self)
                  self.hastarget = False
                  self.targettimer = 0

              if (self.targettimer > 16):
                  self.hastarget = False
                  self.animationframe = 0

    def update(self, player, blockingobjects, scrolloffsetx, scrolloffsety):
        if (self.damaged):
            oldx = self.x
            oldy = self.y
            self.x = self.x + self.damagedvelx
            self.y = self.y + self.damagedvely
            self.move()
            self.damagedtimer += 1
            if (self.enemyclass != 'caw'):
                if (pygame.sprite.spritecollideany(self, blockingobjects)):
                    self.y = oldy
                    self.x = oldx
                    self.move()
            if (self.damagedtimer > 10):
                self.damaged = False
        elif (not(player.clockframes) and self.x > -100 and self.x < 420 and self.y > -100 and self.y < 320):
            if (self.enemyclass == 'caw'):
                self.updatecrow(player, scrolloffsetx, scrolloffsety)
            elif (self.enemyclass == 'kid'):
                self.updatekid(player, blockingobjects, scrolloffsetx, scrolloffsety)
            elif (self.enemyclass == 'gkid'):
                self.updatekid(player, blockingobjects, scrolloffsetx, scrolloffsety, True)
            elif (self.enemyclass == 'hog'):
                self.updatehog(player, blockingobjects, scrolloffsetx, scrolloffsety)
        elif player.clockframes:
            player.clockframes -= 1

    def dodamage(self, mastercane):
        if (mastercane):
            self.health -= 2
        else:
            self.health -= 1
        if (self.health <= 0):
            self.deleted = True

    def distance(self, x, y):
        return sqrt(pow(self.rect.centerx-x, 2) + pow(self.rect.centery-y, 2))

    def move(self):
        self.rect.left = self.x+self.offsetx
        self.rect.top = self.y+self.offsety

    def scroll(self, x, y):
        self.x += x
        self.y += y
        self.move()

    def catchbug(self, player):
        return False

