import os, pygame

from math import sqrt
from random import randint
from string import Template, atoi
from math import degrees, sqrt, sin, cos, atan2

from util import *
from menu import *

from pygame.locals import *

class exitportal(pygame.sprite.Sprite):
    def __init__(self, regionrect, tagname, imagefile, attributes, secret=False):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer
        width = regionrect.width
        height = regionrect.height
        if (width < 0):
            x = regionrect.left + width
        else:
            x = regionrect.left
        if (height < 0):
            y = regionrect.top + height
        else:
            y = regionrect.top
        self.image = pygame.Surface((abs(width), abs(height)))
        self.rect = pygame.Rect((0,0,abs(width),abs(height)))
        itemimage, temp = load_image(imagefile)
        for j in range(0, (self.rect.height/16)+1):
            for i in range(0, (self.rect.width/16)+1):
                self.image.blit(itemimage,(i*16, j*16)) 
        self.move(x, y)
        self.secret = secret
        self.attributes = attributes

        if ('diggable' in self.attributes):
            self.diggable = True
            self.dug = False
        else:
            self.diggable = False
            self.dug = False                
        self.tagname = tagname

    def scroll(self, x, y):
        self.move(self.rect.left+x, self.rect.top+y)

    def move(self, x, y):
        self.rect.left = x
        self.rect.top = y

    def startname(self):
        if 'startname' in self.attributes:
          return self.attributes['startname']
        else:
          return False

    def nextlevel(self):
        if (self.secret):
            return self.attributes['secretnum']
        else:
            return self.attributes['nextlevel']

    def secretnum(self):
        if (self.secret):
            return self.attributes['secretnum']
        else:
            return 0

    def secretitem(self):
        if (self.secret):
            return self.attributes['secretitem']
        else:
            return False

