import os, pygame, sys

from pgu import engine

from math import sqrt
from random import randint
import pygame.mixer

from editscreen import *
from playscreen import *

from pygame.locals import *

def main():
    pygame.mixer.pre_init(44100,-16,2, 1024 * 3)
    mixer = pygame.mixer
    mixer.init(44100)
    mixer.set_num_channels(4)
#    mixer.music.load(os.path.join('./choons/', 'ethergrind.xm'))
#    mixer.music.play(-1)
    sounds = [None] * 15
    sounds[0] = mixer.Sound(os.path.join('./snd/', 'hurt1.wav'))
    sounds[1] = mixer.Sound(os.path.join('./snd/', 'hurt2.wav'))
    sounds[2] = mixer.Sound(os.path.join('./snd/', 'master.wav'))
    sounds[3] = mixer.Sound(os.path.join('./snd/', 'pickup.wav'))
    sounds[4] = mixer.Sound(os.path.join('./snd/', 'powerup.wav'))
    sounds[5] = mixer.Sound(os.path.join('./snd/', 'swing.wav'))
    sounds[6] = mixer.Sound(os.path.join('./snd/', 'coin.wav'))
    sounds[7] = mixer.Sound(os.path.join('./snd/', 'item.wav'))
    sounds[8] = mixer.Sound(os.path.join('./snd/', 'select.wav'))
    flags = 0
    nextfile = False
    editor = False
    filename = ""
    for arg in sys.argv:
        if (nextfile):
            filename = arg
            nextfile = False
            editor = True
        elif (arg == "-f"):
            flags = pygame.fullscreen
        elif (arg == "-e"):
            nextfile = True
    screen = pygame.display.set_mode((640, 480), flags)
    pygame.mouse.set_visible(False);
    pygame.font.init()
    game = engine.Game()
    if (editor):
        pygame.display.set_caption("xml level editor")
        game.run(editscreen(game, sounds, mixer, filename), screen)
    else:
        pygame.display.set_caption("LawnRPG")
        game.run(playscreen(game, sounds, mixer), screen)

if __name__ == '__main__': main()
