import os, pygame

from math import sqrt
from random import randint
from string import Template, atoi
from math import degrees, sqrt, sin, cos, atan2

from util import *
from menu import *

from pygame.locals import *

class npc(pygame.sprite.Sprite):
    def __init__(self, x, y, npcclass, attributes, font):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer
        self.attributes = attributes
        self.npcclass = npcclass
        self.loadimages()
        self.animationtimer = 0
        self.animationframe = 0
        self.targetx = 0
        self.targety = 0
        self.targettimer = 0
        self.hastarget = False
        self.chooseframe()
        self.offsetx = 0
        self.offsety = 0
        self.deleted = False
        self.font = pygame.font.Font("./fonts/freesansbold.ttf", 20)
        self.x = x
        self.y = y
        self.move()

    def loadimages(self):
        if (self.npcclass == 'npc'):
            self.image1d, self.rect = load_image("shopkeeper.png", -1)
            self.image1r = pygame.transform.rotate(self.image1d, 90)
            self.image1u = pygame.transform.rotate(self.image1d, 180)
            self.image1l = pygame.transform.rotate(self.image1d, 270)
            self.facing = FACING_DOWN
        if (self.npcclass == 'sign'):
            self.image1r, self.rect = load_image("sign.png", -1)
            self.image1d = pygame.transform.rotate(self.image1r, 90)
            self.image1l = pygame.transform.rotate(self.image1r, 180)
            self.image1u = pygame.transform.rotate(self.image1r, 270)
            self.facing = FACING_RIGHT

    def chooseframe(self):
        if (self.animationframe == 0):
            if (self.facing == FACING_UP):
                self.image = self.image1u
            elif (self.facing == FACING_DOWN):
                self.image = self.image1d
            elif (self.facing == FACING_LEFT):
                self.image = self.image1l
            elif (self.facing == FACING_RIGHT):
                self.image = self.image1r
    
    def hitplayer(self, player, menu):
        layout = menulayout()
        if ('line1' in self.attributes):
            menuline1 = menuline()
            menuline1.addtext(self.attributes['line1'], self.font, (0, 0, 0), True, 0)
            layout.addline(menuline1)
        if ('line2' in self.attributes):
            menuline1 = menuline()
            menuline1.addtext(self.attributes['line2'], self.font, (0, 0, 0), True, 0)
            layout.addline(menuline1)
        if ('line3' in self.attributes):
            menuline1 = menuline()
            menuline1.addtext(self.attributes['line3'], self.font, (0, 0, 0), True, 0)
            layout.addline(menuline1)
        menu.setlayout(layout)  
        menu.render()

    def move(self):
        self.rect.left = self.x+self.offsetx
        self.rect.top = self.y+self.offsety

    def scroll(self, x, y):
        self.x += x
        self.y += y
        self.move()

