import os, pygame

from math import sqrt
from random import randint
from string import Template, atoi, capitalize

from util import *
from player import *
from mousecursor import *
from pygame.locals import * 
from enemy import *
from bug import *
from menu import *
from npc import *
from exit import *
from golds import *
from heart import *
from clock import *
from secretitem import *
from shopitem import *
from invitem import *
from boulder import *
from explosion import *
from ladder import *
from mastercane import *
import pygame.mixer

from pgu import engine, gui, text, timer

from blockingsprite import *
from regionsprite import *

import xml.dom.minidom
from xml.dom.minidom import Node

##A state may subclass engine.State.
##::
class playscreen(engine.State):
    ##
    ##The init method should load data, etc.  The __init__ method
    ##should do nothing but record the parameters.  If the init method
    ##returns a value, it becomes the new state.
    ##::
    def __init__(self, game, sounds, mixer, player=False, levelfile="map1.xml", playerstartname=False, secretnumber=0, secretitem=False, secretmapfrom=False):
        self.sounds = sounds
        self.mixer = mixer
        self.player = player
        self.levelfile = levelfile
        self.playerstartname = playerstartname
        self.secretnumber = secretnumber
        self.secretitem = secretitem
        self.secretmapfrom = secretmapfrom
        engine.State.__init__(self, game)
    def init(self):
        self.font = pygame.font.Font("./fonts/freesansbold.ttf", 12)
        self.menufont = pygame.font.Font("./fonts/freesansbold.ttf", 20)
        self.fontshown = False
        self.screensurf = pygame.Surface((320, 240)) 
        self.screensurf.set_clip(pygame.Rect((0, 0, 320, 240)))
        self.menusurf = pygame.Surface((320, 240)) 
        self.menusurf.set_colorkey((4, 0, 0))
        self.backimage = pygame.Surface((320, 240))
        self.introdialogs1 = ["You are a peaceful old man, living out your",
                             "retirement in solitude.",
                             "You never thought you would see the prophecy fullfilled.."]
        self.introdialogs2 = ["However, one day, a gang of rowdy, uncouth youngsters",
                             "began to take over the neighborhood...",
                             "And somewhere in your heart, you knew."]
        self.introdialogs3 = ["You knew that the time had come for someone",
                             "to take a stand for the forces of light.",
                             "Against whipper-snappers and varmits."]
        self.introdialogs4 = ["That someone.. is you.",
                              "That time.. is now."]
        self.introdialogs5 = ["With this cane shall vengeance be enacted.",
                              "It is time to tell the world to..."]
        self.introdialog = 1
        if (not(self.secretnumber)):
            itemimage, temp = load_image("grass.png") 
            for j in range(0, (self.backimage.get_height()/16)+1):
                for i in range(0, (self.backimage.get_width()/16)+1):
                    self.backimage.blit(itemimage,(i*16, j*16)) 
        self.timer = timer.Timer(45)
        self.speedometer = timer.Speedometer()
        self.movingup = False
        self.movingdown = False
        self.movingleft = False
        self.movingright = False
        self.scrolloffsetx = 0
        self.scrolloffsety = 0
        self.fpstimer = 0
        self.logo = False
        self.logoimg, temp = load_image("title.png", -1)
        self.logoimg.set_alpha(255)
        self.liveheart, temp = load_image("item/liveheart.png", -1)
        self.deadheart, temp = load_image("item/deadheart.png", -1)
        self.caneicon, temp = load_image("item/itemselectcane.png", -1)
        self.neticon, temp = load_image("item/itemselectnet.png", -1)
        self.maxhealth = 5
        self.health = 3
        self.blockingsprites = []
        self.terrainsprites = []
        self.enemies = []
        self.npcs = []
        self.exits = []
        self.powerups = []
        self.boulders = []
        self.explosions = []
        self.ladder = ladder(0, 0)
        self.ladder.active = False
        self.watersprites = []
        self.watergroup = pygame.sprite.OrderedUpdates(self.watersprites)
        self.laddergroup = pygame.sprite.OrderedUpdates((self.ladder))
        self.bouldergroup = pygame.sprite.OrderedUpdates(self.boulders)
        self.enemygroup = pygame.sprite.OrderedUpdates(self.enemies)
        self.blockinggroup = pygame.sprite.OrderedUpdates(self.blockingsprites)
        self.terraingroup = pygame.sprite.OrderedUpdates(self.terrainsprites)
        self.npcgroup = pygame.sprite.OrderedUpdates(self.npcs)
        self.exitgroup = pygame.sprite.OrderedUpdates(self.exits)
        self.powerupgroup = pygame.sprite.OrderedUpdates(self.powerups)
        self.explosiongroup = pygame.sprite.OrderedUpdates(self.explosions)
        layout = menulayout()
        self.menu = menu("boringgray.png", pygame.Rect(0, 380, 640, 100), layout, 4, 2)
        self.menu.render()
        self.menu.hide()
        self.menugroup = pygame.sprite.RenderPlain((self.menu))
        if (not(self.secretnumber)):
            self.loadlevel(self.levelfile)
        else:
            self.loadlevel("sekrit.xml")
        self.playergroup = pygame.sprite.OrderedUpdates((self.player))
        self.scrolltoinitial()
        self.player.menudirty = True
        self.player.clockframes = 0
        self.intro = False
        if (self.player.intro):
            layout = menulayout()
            for line in self.introdialogs1:
                menuline1 = menuline()
                menuline1.addtext(line, self.menufont, (0, 0, 0), True, 0)
                layout.addline(menuline1)
            self.menu.setlayout(layout)
            self.menu.render()
            self.intro = True
            self.player.intro = False
        elif (self.player.health <= 0):
            layout = menulayout()
            menuline1 = menuline()
            menuline1.addtext("You died.", self.menufont, (0, 0, 0), True, 0)
            layout.addline(menuline1)
            menuline1 = menuline()
            menuline1.addtext("You have been returned to your home.", self.menufont, (0, 0, 0), True, 0)
            layout.addline(menuline1)
            menuline1 = menuline()
            menuline1.addtext("In addition, half of your money has been deducted.", self.menufont, (0, 0, 0), True, 0)
            layout.addline(menuline1)
            menuline1 = menuline()
            menuline1.addtext("Try to be more careful next time!", self.menufont, (0, 0, 0), True, 0)
            layout.addline(menuline1)
            self.menu.setlayout(layout)
            self.menu.render()
            self.player.health = self.player.maxhealth
            self.damaged = False
            self.player.golds /= 2
            round(self.player.golds, 2)
    def loadlevel(self, filename):
        doc = xml.dom.minidom.parse("maps/" + filename)
        for level in doc.getElementsByTagName("level"):
            levelname = level.getElementsByTagName("name");
            for i in levelname:
                for j in i.childNodes:
                    if j.nodeType == Node.TEXT_NODE:
                        self.levelname = j.nodeValue
            leveldata = level.getElementsByTagName("leveldata");
            for level in leveldata:
                for node in level.childNodes:    
                    if node.nodeType == Node.ELEMENT_NODE:
                        if (node.nodeName == "player"):
                            x = int(node.getAttribute("x"))
                            y = int(node.getAttribute("y"))
                            attributes = {}
                            for attr in node.attributes.keys():
                                if (attr != "x" and attr != "y" and attr != "width" and attr != "height"):
                                    attributes[attr] = node.getAttribute(attr)
                            placed = False
                            if (self.player == False):
                                self.player = player(x, y, self.sounds)
                                placed = True
                            elif ('startname' in attributes and attributes['startname'] == self.playerstartname):
                                self.player.move(x, y)
                                placed = True
                            elif (not self.playerstartname and not('startname' in attributes)):
                                self.player.move(x, y)
                                placed = True
                            if (placed and 'line1' in attributes):
                                layout = menulayout()
                                if ('line1' in attributes):
                                    menuline1 = menuline()
                                    menuline1.addtext(attributes['line1'], self.menufont, (0, 0, 0), True, 0)
                                    layout.addline(menuline1)
                                if ('line2' in attributes):
                                    menuline1 = menuline()
                                    menuline1.addtext(attributes['line2'], self.menufont, (0, 0, 0), True, 0)
                                    layout.addline(menuline1)
                                if ('line3' in attributes):
                                    menuline1 = menuline()
                                    menuline1.addtext(attributes['line3'], self.menufont, (0, 0, 0), True, 0)
                                    layout.addline(menuline1)
                                self.menu.setlayout(layout)
                                self.menu.render()
                        elif (node.nodeName == 'exit'):
                            x = int(node.getAttribute("x"))
                            y = int(node.getAttribute("y"))
                            width = int(node.getAttribute("width"))
                            height = int(node.getAttribute("height"))
                            regionrect = pygame.Rect((x,y,width,height))
                            attributes = {}
                            for attr in node.attributes.keys():
                                if (attr != "x" and attr != "y" and attr != "width" and attr != "height"):
                                    attributes[attr] = node.getAttribute(attr)
                            if (self.secretnumber):
                                attributes['nextlevel'] = self.secretmapfrom
                                attributes['startname'] = "secret" + str(self.secretnumber)
                            self.exits.append(exitportal(regionrect, node.nodeName, IMAGE_FILES[node.nodeName], attributes))  
                            self.exitgroup.add(self.exits[-1])
                        elif (REGION_NODES.count(node.nodeName)):
                            x = int(node.getAttribute("x"))
                            y = int(node.getAttribute("y"))
                            width = int(node.getAttribute("width"))
                            height = int(node.getAttribute("height"))
                            regionrect = pygame.Rect((x,y,width,height))
                            attributes = {}
                            for attr in node.attributes.keys():
                                if (attr != "x" and attr != "y" and attr != "width" and attr != "height"):
                                    attributes[attr] = node.getAttribute(attr)
                            if (node.nodeName == 'water'):
                                self.watersprites.append(regionsprite(regionrect, node.nodeName, IMAGE_FILES[node.nodeName], attributes))
                                self.watergroup.add(self.watersprites[-1])
                            elif (BLOCKING_REGIONS.count(node.nodeName)):
                                self.blockingsprites.append(regionsprite(regionrect, node.nodeName, IMAGE_FILES[node.nodeName], attributes))
                                self.blockinggroup.add(self.blockingsprites[-1])
                            elif (node.nodeName == 'secretexit'):
                                self.exits.append(exitportal(regionrect, node.nodeName, IMAGE_FILES[node.nodeName], attributes, True))  
                                self.exitgroup.add(self.exits[-1])
                            else:
                                self.terrainsprites.append(regionsprite(regionrect, node.nodeName, IMAGE_FILES[node.nodeName], attributes))
                                self.terraingroup.add(self.terrainsprites[-1])
                        elif (POINT_NODES.count(node.nodeName)):
                            x = int(node.getAttribute("x"))
                            y = int(node.getAttribute("y"))
                            attributes = {}
                            for attr in node.attributes.keys():
                                if (attr != "x" and attr != "y"):
                                    attributes[attr] = node.getAttribute(attr)
                            if (GOLDS_POINTS.count(node.nodeName)):
                                self.powerups.append(golds(x, y, GOLDS_AMOUNT[node.nodeName])) 
                                self.powerupgroup.add(self.powerups[-1])
                            elif (node.nodeName == 'heart'):
                                self.powerups.append(heart(x, y, False)) 
                                self.powerupgroup.add(self.powerups[-1])
                            elif (node.nodeName == 'heartframe'):
                                if (not(self.player.heartframes.count(attributes['framenum']))):
                                    self.powerups.append(heart(x, y, True, attributes['framenum'])) 
                                    self.powerupgroup.add(self.powerups[-1])
                            elif (node.nodeName == 'clock'):
                                self.powerups.append(clock(x, y)) 
                                self.powerupgroup.add(self.powerups[-1])
                            elif (node.nodeName == 'boulder'):
                                self.boulders.append(boulder(x, y)) 
                                self.bouldergroup.add(self.boulders[-1])
                            elif (node.nodeName == 'invitem'):
                                if (not(self.player.inv.count(attributes['itemtype']))):
                                    self.powerups.append(invitem(x, y, attributes['itemtype'], IMAGE_FILES[attributes['itemtype']])) 
                                    self.powerupgroup.add(self.powerups[-1])
                            elif (node.nodeName == 'secretitem'):
                                if (not(self.player.secretitems.count(self.secretnumber))):
                                    self.powerups.append(secretitem(x, y, self.secretitem, IMAGE_FILES[self.secretitem], self.secretnumber)) 
                                    self.powerupgroup.add(self.powerups[-1])
                            elif (node.nodeName == 'shopitem'):
                                self.powerups.append(shopitem(x, y, attributes['itemtype'], IMAGE_FILES[attributes['itemtype']], attributes['cost'], self.font)) 
                                self.powerupgroup.add(self.powerups[-1])
                            elif (BLOCKING_POINTS.count(node.nodeName)):
                                self.blockingsprites.append(blockingsprite(x, y, node.nodeName, IMAGE_FILES[node.nodeName], attributes))  
                                self.blockinggroup.add(self.blockingsprites[-1])
                            elif (NPC_POINTS.count(node.nodeName)):
                                self.npcs.append(npc(x, y, node.nodeName, attributes, self.font))  
                                self.npcgroup.add(self.npcs[-1])
                            elif (node.nodeName == "mastercane"):
                                self.npcs.append(mastercane(x, y))  
                                self.npcgroup.add(self.npcs[-1])
                            elif (node.nodeName == 'bug'):
                                self.enemies.append(bug(x, y))
                                self.enemygroup.add(self.enemies[-1])
                            elif (ENEMY_POINTS.count(node.nodeName)):
                                self.enemies.append(enemy(x, y, node.nodeName, attributes))
                                self.enemygroup.add(self.enemies[-1])
                            else:
                                self.terrainsprites.append(blockingsprite(x, y, node.nodeName, IMAGE_FILES[node.nodeName], attributes))  
                                self.terraingroup.add(self.terrainsprites[-1])
    
    def scrolltoinitial(self):
        (scrollx, scrolly, nextlevel, playerstartname, secretnum, secretitem) = self.player.update(self.blockinggroup, self.enemygroup, self.npcgroup, self.menu, self.exitgroup, self.powerups, self.boulders, self.watersprites, self.ladder, True)
        if (scrollx != 0 or scrolly != 0):
            self.scrollall(scrollx, scrolly)
    def droploot(self, x, y):
        randloot = randint(0, 10)
        if (randloot < 3):
            self.powerups.append(heart(x, y, False)) 
            self.powerupgroup.add(self.powerups[-1])
        elif (randloot == 4):
            self.powerups.append(golds(x, y, 1.00)) 
            self.powerupgroup.add(self.powerups[-1])
        elif (randloot < 6):
            self.powerups.append(golds(x, y, 0.10)) 
            self.powerupgroup.add(self.powerups[-1])
        elif (randloot < 8):
            self.powerups.append(golds(x, y, 0.01)) 
            self.powerupgroup.add(self.powerups[-1])
    def deleteeverything(self):
        for i in self.enemies:
            if (i.deleted):
                if (i.enemyclass != 'bug'):
                    self.explosions.append(explosion(i.rect.left, i.rect.top))
                    self.explosiongroup.add(self.explosions[-1])  
                    self.droploot(i.rect.left, i.rect.top)
                self.enemygroup.remove(i)
                self.enemies.remove(i)
                del i
        for i in self.powerups:
            if (i.deleted):
                self.powerupgroup.remove(i)
                self.powerups.remove(i)
                del i   
        for i in self.blockingsprites:
            if (i.deleted):
                self.explosions.append(explosion(i.rect.left, i.rect.top))
                self.explosiongroup.add(self.explosions[-1])  
                self.blockinggroup.remove(i)
                self.blockingsprites.remove(i)
                del i   
        for i in self.explosions:
            if (i.deleted):
                self.explosions.remove(i)
                self.explosiongroup.remove(i)
                del i   
        for i in self.npcs:
            if (i.deleted):
                self.npcs.remove(i)
                self.npcgroup.remove(i)
                del i   
    def scrollall(self, scrollx, scrolly):
        for i in self.blockingsprites:
            i.scroll(scrollx, scrolly)
        for i in self.terrainsprites:
            i.scroll(scrollx, scrolly)
        for i in self.enemies:
            i.scroll(scrollx, scrolly)
        for i in self.npcs:
            i.scroll(scrollx, scrolly)
        for i in self.exits:
            i.scroll(scrollx, scrolly)
        for i in self.powerups:
            i.scroll(scrollx, scrolly)
        for i in self.boulders:
            i.scroll(scrollx, scrolly)
        for i in self.explosions:
            i.scroll(scrollx, scrolly)
        for i in self.watersprites:
            i.scroll(scrollx, scrolly)
    def nextintro(self):
        self.introdialog += 1
        if (self.introdialog == 2):
            currdiag = self.introdialogs2
        elif (self.introdialog == 3):
            currdiag = self.introdialogs3
        elif (self.introdialog == 4):
            currdiag = self.introdialogs4
        elif (self.introdialog == 5):
            currdiag = self.introdialogs5
        else:
            self.intro = False
            self.logo = True
            self.logotimer = 0
        if (self.intro):
            layout = menulayout()
            for line in currdiag:
                menuline1 = menuline()
                menuline1.addtext(line, self.menufont, (0, 0, 0), True, 0)
                layout.addline(menuline1)
            self.menu.setlayout(layout)
            self.menu.render()
    ##Theopaint method is called once.  If you call repaint(), it
    ##will be called again.
    ##::
    def paint(self,s): 
        pygame.display.flip()
    ##
    ##Every time an event occurs, event is called.  If the event method
    ##returns a value, it will become the new state.
    ##::
    def event(self,e): 
        if (self.menu.hidden):
            if e.type is KEYDOWN:
                if e.key == K_UP:
                    self.movingup = True
                    self.movingdown = False
                elif e.key == K_DOWN:
                    self.movingdown = True
                    self.movingup = False
                elif e.key == K_LEFT:
                    self.movingleft = True
                    self.movingright = False
                elif e.key == K_RIGHT:
                    self.movingright = True
                    self.movingleft = False
                elif e.key == K_LALT:
                    if (self.player.item):
                        self.player.util(self.ladder)
                        self.sounds[7].play()
                elif e.key == K_SPACE:
                    self.sounds[5].play()
                    self.player.attack()
                elif e.key == K_TAB:
                    self.sounds[8].play()
                    self.player.nextitem()
                elif e.key == K_ESCAPE:
                    return engine.Quit(self.game)
            elif e.type is KEYUP:
                if e.key == K_UP:
                    self.movingup = False
                elif e.key == K_DOWN:
                    self.movingdown = False
                elif e.key == K_LEFT:
                    self.movingleft = False
                elif e.key == K_RIGHT:
                    self.movingright = False
        else:
            if e.type is KEYDOWN:
                if e.key == K_RETURN:
                    self.menu.hide()
                    if (self.intro):
                        self.nextintro()
    ##
    ##Loop is called once a frame.  It should contain all the
    ##logic.  If the loop method returns a value it will become the
    ##new state.
    ##::
    def loop(self):
        self.player.setmove(self.movingup, self.movingdown, self.movingleft, self.movingright)
        nextlevel = False
        playerstartname = False
        if (self.menu.hidden):
            for i in self.explosions:
                i.update()
            (scrollx, scrolly, nextlevel, playerstartname, secretnum, secretitem) = self.player.update(self.blockinggroup, self.enemygroup, self.npcgroup, self.menu, self.exitgroup, self.powerups, self.boulders, self.watersprites, self.ladder)
            if (scrollx != 0 or scrolly != 0):
                self.scrollall(scrollx, scrolly)
                if (pygame.sprite.spritecollideany(self.player, self.npcgroup)):
                    npccollisions = pygame.sprite.spritecollide(self.player, self.npcgroup, False)
                    if (not(self.player.damaged)):
                        for i in npccollisions:
                            i.hitplayer(self.player, self.menu)
                    self.scrollall(-scrollx, -scrolly)
                elif (pygame.sprite.spritecollideany(self.player, self.exitgroup)):
                    exitcollisions = pygame.sprite.spritecollide(self.player, self.exitgroup, False)
                    if (not(exitcollisions[0].diggable) or exitcollisions[0].dug):
                        nextlevel = exitcollisions[0].nextlevel()
                        secretnum = exitcollisions[0].secretnum()
                        secretitem = exitcollisions[0].secretitem()
                        playerstartname = exitcollisions[0].startname()
                    else:
                        self.scrolloffsetx -= scrollx
                        self.scrolloffsety -= scrolly
                elif (pygame.sprite.spritecollideany(self.player, self.blockinggroup)):
                    self.scrollall(-scrollx, -scrolly)
                elif (not(self.player.damaged) and pygame.sprite.spritecollideany(self.player, self.enemygroup)):
                    enemycollisions = pygame.sprite.spritecollide(self.player, self.enemygroup, False)
                    dohit = False
                    for i in enemycollisions:
                        if (not(i.enemyclass == 'hog' and i.animationframe == 0)): 
                            dohit = True
                            self.player.hitenemy(i)
                    if (dohit):
                        self.scrollall(-scrollx, -scrolly)
                elif (pygame.sprite.spritecollideany(self.player,self.bouldergroup)):
                    bouldercollisions = pygame.sprite.spritecollide(self.player, self.bouldergroup, False)
                    if (bouldercollisions[0].push(self.player) and not(len(bouldercollisions) > 1)):
                        self.player.pushing = True
                        self.player.chooseframe()
                        bouldercollisions[0].scroll(-scrollx, -scrolly)
                        self.scrolloffsetx -= scrollx
                        self.scrolloffsety -= scrolly
                    else:
                        self.scrollall(-scrollx, -scrolly)
                elif (pygame.sprite.spritecollideany(self.player,self.watergroup)):
                    self.scrollall(-scrollx, -scrolly)
                else:
                    self.scrolloffsetx -= scrollx
                    self.scrolloffsety -= scrolly
                if (pygame.sprite.spritecollideany(self.player, self.powerupgroup)):
                    for i in pygame.sprite.spritecollide(self.player, self.powerups, False):
                        if (not i.deleted):
                            self.sounds[6].play()
                            i.get(self.player)
            if (self.player.utility):
                if (self.player.item == ITM_AXE):
                    for i in self.blockingsprites:
                        if (i.rect.colliderect(self.player.attackbox)):
                            i.util(self.player)
                if (self.player.item == ITM_SHOVEL and not(self.secretnumber)):
                    collided = False
                    for i in self.blockingsprites:
                        if (not(collided) and i.rect.colliderect(self.player.attackbox)):
                            collided = True
                    for i in self.terrainsprites:
                        if (not(collided) and i.rect.colliderect(self.player.attackbox)):
                            collided = True
                    for i in self.boulders:
                        if (not(collided) and i.rect.colliderect(self.player.attackbox)):
                            collided = True
                    for i in self.npcs:
                        if (not(collided) and i.rect.colliderect(self.player.attackbox)):
                            collided = True
                    for i in self.exits:
                        if (not(collided) and i.rect.colliderect(self.player.attackbox)):
                            self.terrainsprites.append(blockingsprite(i.rect.left, i.rect.top, "bighole", "bighole.png", {}))  
                            self.terraingroup.add(self.terrainsprites[-1])
                            i.dug = True
                            collided = True
                    if (not(collided)):
                        self.terrainsprites.append(blockingsprite(self.player.attackbox.left, self.player.attackbox.top, "plant1", "plant1.png", {}))  
                        self.terraingroup.add(self.terrainsprites[-1])
                if (self.player.item == ITM_NET and self.player.attackingframe == 3):
                    for i in self.enemies:
                        if (i.rect.colliderect(self.player.attackbox)):
                            i.catchbug(self.player)
            for i in self.enemies:
                i.update(self.player, self.blockinggroup, self.scrolloffsetx, self.scrolloffsety)
            self.speedometer.tick()
            self.timer.tick()
            if (self.fpstimer > 200):
                print "FPS: " + str(self.speedometer.fps) + "/45"
                self.fpstimer = 0
            else:
                self.fpstimer += 1
            if (not(self.menu.hidden)):
                self.movingup = False
                self.movingdown = False
                self.movingleft = False
                self.movingright = False
        if (self.fpstimer % 20):
            self.deleteeverything()
        if (nextlevel):
            if (secretnum):
                return playscreen(self.game, self.sounds, self.mixer, self.player, nextlevel, playerstartname, secretnum, secretitem, self.levelfile)
            else:
                return playscreen(self.game, self.sounds, self.mixer, self.     player, nextlevel, playerstartname)
        if (self.player.health <= 0 and not(self.player.damaged)):
            return playscreen(self.game, self.sounds, self.mixer, self.player, "map1.xml")
        if (self.logo):
            self.logotimer += 1
            if (self.logotimer < 255):
                self.logoimg.set_alpha(self.logotimer)
            elif (self.logotimer < 512):
                self.logoimg.set_alpha(512-self.logotimer)
            else:
                self.logo = False
    ##
    ##Update is called once a frame.  It should update the display.
    ##::
    def update(self,screen):
        tempx = self.scrolloffsetx%320
        tempy = self.scrolloffsety%240
        self.screensurf.blit(self.backimage, (-tempx, -tempy))
        self.screensurf.blit(self.backimage, (320-tempx, -tempy))
        self.screensurf.blit(self.backimage, (-tempx, 240-tempy))
        self.screensurf.blit(self.backimage, (320-tempx, 240-tempy))
        self.terraingroup.draw(self.screensurf)
        self.watergroup.draw(self.screensurf)
        self.blockinggroup.draw(self.screensurf)
        self.bouldergroup.draw(self.screensurf)
        #if (self.ladder.active):
        #    self.laddergroup.draw(self.screensurf)
        self.powerupgroup.draw(self.screensurf)
        #pygame.draw.rect(self.screensurf, (255, 255, 0), self.player.rect)
        #if (self.player.attacking):
        #    pygame.draw.rect(self.screensurf, (255, 0, 0), self.player.attackbox)
        self.enemygroup.draw(self.screensurf)
        self.npcgroup.draw(self.screensurf)
        if (not(self.player.damaged) or self.player.damagedtimer % 2):
            self.playergroup.draw(self.screensurf)
        #for i in self.enemies:
        #    pygame.draw.rect(self.screensurf, (0, 0, 255), i.rect)
        #for i in self.exits:
        #    pygame.draw.rect(self.screensurf, (0, 0, 255), i.rect)
        self.explosiongroup.draw(self.screensurf)
        if (self.player.menudirty):
            self.menusurf.fill((4,0,0))
            for i in range(0, self.player.maxhealth):
                if (self.player.health > i):
                    self.menusurf.blit(self.liveheart, (i*16, 0))
                else:
                    self.menusurf.blit(self.deadheart, (i*16, 0))
            if (self.player.mastercane):
                self.menusurf.blit(self.player.mastercaneimage, (272, 0))
            else:
                self.menusurf.blit(self.player.normalcaneimage, (272, 0))
            if (self.player.item):
                self.menusurf.blit(self.player.itemimage, (294, 0))
            strgolds = "%.2f" % self.player.golds
            self.drawmenutext(self.menusurf, (272, 18), (255, 255, 255), "$" + strgolds)
            self.player.menudirty = False
        self.screensurf.blit(self.menusurf, (0,0))
        if (self.logo):
            self.screensurf.blit(self.logoimg, (0,0))
        pygame.transform.scale(self.screensurf, (640, 480), screen)
        if (not(self.menu.hidden)):
            self.menugroup.draw(screen)
        pygame.display.flip() #better to do updates
    ##

    def drawmenutext(self, screen, position, color, string):
        x, y = position
        text.writewrap(screen,self.font,pygame.Rect(x+2,y+2,640,30),(0,0,0),    string)
        text.writewrap(screen,self.font,pygame.Rect(x,y,640,30),color,string)

