import os, pygame

from math import sqrt
from random import randint
from string import Template, atoi, capitalize

from mousecursor import *
from menu import *

from pgu import engine, gui, text, timer

##A state may subclass engine.State.
##::
class testscreen(engine.State):
    ##
    ##The init method should load data, etc.  The __init__ method
    ##should do nothing but record the parameters.  If the init method
    ##returns a value, it becomes the new state.
    ##::
    def __init__(self, game):
        engine.State.__init__(self, game)
    def init(self):
        #if not(self.mixer.music.get_busy()):
        #self.mixer.music.load(os.path.join('./jams/', 'stage.mp3'))
        #self.mixer.music.play(-1)
        self.timer = timer.Timer(60)
        self.speedometer = timer.Speedometer()
        self.backimg = load_image("background.png")
        self.back = self.backimg[0]
        self.font = pygame.font.Font("./fonts/freesansbold.ttf", 18)
        statusmenu = menulayout()
        self.statusmenu = menu("boringgray.png", pygame.Rect(0, 380, 640, 100), statusmenu, 4, 2)
        self.statusmenu.render()
        self.statusgroup = pygame.sprite.RenderPlain((self.statusmenu))
        menuline1 = menuline()
        menuline1.addtext("Fight", self.font, (0, 0, 0), True, 0)
        menuline2 = menuline()
        menuline2.addtext("Magic", self.font, (0, 0, 0), True, 1)
        menuline3 = menuline()
        menuline3.addtext("Item", self.font, (0, 0, 0), True, 2)
        mymenulayout = menulayout()
        mymenulayout.addline(menuline1)
        mymenulayout.addline(menuline2)
        mymenulayout.addline(menuline3)
        self.mymenu = menu("boringgray.png", pygame.Rect(32,380,150,100), mymenulayout, 4, 2)
        self.mymenu.render()
        self.myselectcursor = selectcursor("selectcursor.png", 0, -34, +4)
        self.myselectcursor.move(self.mymenu.getcursorposition(self.myselectcursor.selectid))
        self.menugroup = pygame.sprite.RenderPlain((self.mymenu))
        self.cursor = mousecursor()
        self.cursorgroup = pygame.sprite.RenderPlain((self.cursor, self.myselectcursor))
        
    ##
    ##The paint method is called once.  If you call repaint(), it
    ##will be called again.
    ##::
    def paint(self,s): 
        pygame.display.flip()
    ##
    ##Every time an event occurs, event is called.  If the event method
    ##returns a value, it will become the new state.
    ##::
    def event(self,e):
            if e.type is KEYDOWN:
                if e.key == K_ESCAPE:
                    return engine.Quit(self.game, 1)
                elif e.key == K_DOWN:
                    self.myselectcursor.selectid = self.mymenu.getnextitem(self.myselectcursor.selectid)
                    self.myselectcursor.move(self.mymenu.getcursorposition(self.myselectcursor.selectid))
                elif e.key == K_UP:
                    self.myselectcursor.selectid = self.mymenu.getpreviousitem(self.myselectcursor.selectid)
                    self.myselectcursor.move(self.mymenu.getcursorposition(self.myselectcursor.selectid))

    ##
    ##Loop is called once a frame.  It should contain all the
    ##logic.  If the loop method returns a value it will become the
    ##new state.
    ##::
    def loop(self):
        self.speedometer.tick()
        self.timer.tick()
        self.cursor.update()
    ##
    ##Update is called once a frame.  It should update the display.
    ##::
    def update(self,screen):
        screen.blit(self.back, (0,0))
        text.writewrap(screen,self.font,pygame.Rect(1,1,320,200),(0,0,0),"FPS: " + str(self.speedometer.fps))
        self.statusgroup.draw(screen)
        self.menugroup.draw(screen) 
        self.cursorgroup.draw(screen)
        pygame.display.flip() #better to do updates
    ##
